"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.renderPoints = exports.dump = exports.points = exports.value = void 0;
const value = (params) => {
    return (points) => {
        const args = params?.args;
        if (!args || !args.mode) {
            return points;
        }
        const from = args.mode;
        const targetItems = args.targetItems ? args.targetItems : [];
        const targetPoints = points.filter((point) => targetItems.indexOf(point[from]) > -1);
        return targetPoints;
    };
};
exports.value = value;
const points = (points) => points;
exports.points = points;
const dump = (points) => {
    console.dir(points, { depth: 10 });
    if (!points.length) {
        return undefined;
    }
    return points;
};
exports.dump = dump;
const renderPoints = (points) => {
    return points.map((point) => point.value).join("|");
};
exports.renderPoints = renderPoints;
//# sourceMappingURL=cell.js.map