"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.all = exports.filterBy = exports.filterByDataTag = void 0;
exports.filterByDataTag = (function (targetTag, label) {
    return (points) => {
        return {
            points: points.filter((point) => point.tags.find((tag) => tag.value === targetTag.value)),
            label: label,
        };
    };
});
exports.filterBy = (function (section, key) {
    return (points) => {
        return {
            points: points.filter((point) => {
                if ((section === "row" || section === "column") &&
                    point[section] === key) {
                    return true;
                }
                else {
                    return point.tags.find((tag) => tag.categoryId === Number(section) && tag.value === key);
                }
            }),
            label: key,
        };
    };
});
const all = function (section) {
    return (keys) => {
        if (!keys.hasOwnProperty(section)) {
            // throw new Error('Filter "all": no keys for section: ' + section);
            return [];
        }
        return Object.keys(keys[section]).map((key) => (0, exports.filterBy)(section, key));
    };
};
exports.all = all;
//# sourceMappingURL=filter.js.map