"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.vd = exports.setNestedClause = exports.clauseCallback = exports.getTagGroupsByCategory = exports.getNestedClause = void 0;
const getNestedClause = (selectionTags) => {
    const tagGroups = (0, exports.getTagGroupsByCategory)(selectionTags);
    if (!tagGroups || !tagGroups[0]) {
        return false;
    }
    let clause = (0, exports.clauseCallback)(tagGroups[0]);
    for (let i in tagGroups) {
        if (Number(i) > 0) {
            (0, exports.setNestedClause)(clause, tagGroups[i]);
        }
    }
    return clause;
};
exports.getNestedClause = getNestedClause;
const getTagGroupsByCategory = (selectionTags) => {
    const groups = {};
    selectionTags.forEach((tag) => {
        if (!groups[tag.categoryId]) {
            groups[tag.categoryId] = [];
        }
        if (!groups[tag.categoryId].includes(tag.id)) {
            groups[tag.categoryId].push(tag.id);
        }
    });
    return Object.values(groups);
};
exports.getTagGroupsByCategory = getTagGroupsByCategory;
const clauseCallback = (ids) => {
    const selector = ids.length > 1 ? { in: ids } : ids[0];
    return {
        tags: {
            some: {
                id: selector,
            },
        },
    };
};
exports.clauseCallback = clauseCallback;
const setNestedClause = (clause, ids) => {
    if (!clause.AND) {
        clause.AND = (0, exports.clauseCallback)(ids);
    }
    else {
        (0, exports.setNestedClause)(clause.AND, ids);
    }
};
exports.setNestedClause = setNestedClause;
const vd = (v, keys) => {
    if (keys && typeof v === "object") {
        v = Object.keys(v);
    }
    console.log("--------- [automizer-data] ---------");
    // @ts-ignore
    console.log(new Error().stack.split("\n")[2].trim());
    console.dir(v, { depth: 10 });
    console.log();
};
exports.vd = vd;
//# sourceMappingURL=helper.js.map