"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
class QueryCache {
    constructor() {
        this.buffer = [];
        this.exists = (selector, isNonGreedy) => {
            const key = this.getKey(selector, isNonGreedy);
            return !!this.buffer.find((obj) => obj.key === key);
        };
        this.get = (selector, isNonGreedy) => {
            const key = this.getKey(selector, isNonGreedy);
            // vd('from cache: ' + key);
            return this.buffer.find((obj) => obj.key === key);
        };
        this.set = (selector, isNonGreedy, data) => {
            if (!this.exists(selector, isNonGreedy)) {
                const key = this.getKey(selector, isNonGreedy);
                // vd('to cache: ' + key);
                this.buffer.push({
                    key,
                    ...data,
                });
            }
        };
        this.clear = () => {
            this.buffer = [];
        };
        this.getKey = (selector, isNonGreedy) => {
            return selector.join("|") + (isNonGreedy ? "-ng" : "");
        };
    }
}
exports.default = QueryCache;
//# sourceMappingURL=queryCache.js.map