"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
class TagsCache {
    constructor() {
        this.buffer = [];
        this.init = async (prisma) => {
            this.prisma = prisma;
            this.buffer = await this.prisma.tag.findMany();
            console.log("TagsCache initalized with " + this.buffer.length + " tags");
        };
        this.exists = (name, categoryId) => {
            return !!this.get(name, categoryId);
        };
        this.tagExists = (tag) => {
            return !!this.buffer.find((obj) => obj.id === tag.id);
        };
        this.getMany = (categoryId) => {
            if (!categoryId) {
                return this.buffer;
            }
            return this.buffer.filter((obj) => obj.categoryId === categoryId);
        };
        this.get = (name, categoryId) => {
            return this.buffer.find((obj) => obj.name === name && obj.categoryId === categoryId);
        };
        this.create = async (name, categoryId) => {
            const newTag = await this.prisma.tag.create({
                data: {
                    name: name,
                    category: {
                        connect: { id: categoryId },
                    },
                },
            });
            console.log("TagsCache created tag with id " + newTag.id + "");
            this.set(newTag);
            return newTag;
        };
        this.set = (tag) => {
            if (!this.tagExists(tag)) {
                this.buffer.push(tag);
            }
        };
    }
}
exports.default = TagsCache;
//# sourceMappingURL=tagsCache.js.map