import { DataPoint } from "./types/types";
import { InputKeys } from "./modelizer/modelizer-types";
export default class Keys {
    #private;
    addPoints(points: DataPoint[]): void;
    /**
     * Retreive all untouched unique row and column keys and tags from all
     * DataPoints. Object keys are 'row', 'col' and each used categoryId.
     * @returns InputKeys Object with section keys and array of strings values.
     */
    getInputKeys(): InputKeys;
    setInputKeys(section: keyof Keys, keys: string[]): void;
    getCategoryKeys(categoryId: number): string[];
    updateCategoryKeys(categoryId: number, keys: string[]): void;
}
