"use strict";
var __classPrivateFieldGet = (this && this.__classPrivateFieldGet) || function (receiver, state, kind, f) {
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a getter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot read private member from an object whose class did not declare it");
    return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
};
var _Keys_instances, _Keys_inputKeys, _Keys_addPoint, _Keys_addInputCategoryKey;
Object.defineProperty(exports, "__esModule", { value: true });
class Keys {
    constructor() {
        _Keys_instances.add(this);
        /**
         * Stores all row keys, column keys and tags before any modification is
         * applied. Useful to compare the original values and output.
         * @private
         */
        _Keys_inputKeys.set(this, {
            row: [],
            column: [],
            nested: [],
            category: [],
            byCategoryId: (id) => {
                return (__classPrivateFieldGet(this, _Keys_inputKeys, "f").category.find((inputKey) => inputKey.categoryId === id)
                    ?.keys || []);
            },
            hasKey: (key, section) => {
                if (typeof section === "number") {
                    return __classPrivateFieldGet(this, _Keys_inputKeys, "f").byCategoryId(section).includes(key);
                }
                return __classPrivateFieldGet(this, _Keys_inputKeys, "f")[section].includes(key);
            },
        });
    }
    addPoints(points) {
        points.forEach((point) => {
            __classPrivateFieldGet(this, _Keys_instances, "m", _Keys_addPoint).call(this, point);
        });
    }
    /**
     * Retreive all untouched unique row and column keys and tags from all
     * DataPoints. Object keys are 'row', 'col' and each used categoryId.
     * @returns InputKeys Object with section keys and array of strings values.
     */
    getInputKeys() {
        return __classPrivateFieldGet(this, _Keys_inputKeys, "f");
    }
    setInputKeys(section, keys) {
        __classPrivateFieldGet(this, _Keys_inputKeys, "f")[section] = keys;
    }
    getCategoryKeys(categoryId) {
        return __classPrivateFieldGet(this, _Keys_inputKeys, "f").byCategoryId(categoryId);
    }
    updateCategoryKeys(categoryId, keys) {
        const existing = __classPrivateFieldGet(this, _Keys_inputKeys, "f").category.find((inputKey) => inputKey.categoryId === categoryId);
        if (existing) {
            existing.keys = keys;
        }
        else {
            __classPrivateFieldGet(this, _Keys_inputKeys, "f").category.push({
                categoryId,
                keys,
            });
        }
    }
}
_Keys_inputKeys = new WeakMap(), _Keys_instances = new WeakSet(), _Keys_addPoint = function _Keys_addPoint(point) {
    if (!__classPrivateFieldGet(this, _Keys_inputKeys, "f").row.includes(point.row)) {
        __classPrivateFieldGet(this, _Keys_inputKeys, "f").row.push(point.row);
    }
    if (!__classPrivateFieldGet(this, _Keys_inputKeys, "f").column.includes(point.column)) {
        __classPrivateFieldGet(this, _Keys_inputKeys, "f").column.push(point.column);
    }
    point.tags.forEach((tag) => {
        __classPrivateFieldGet(this, _Keys_instances, "m", _Keys_addInputCategoryKey).call(this, tag);
    });
    const isNestedParent = point.getMeta("isParent");
    if (isNestedParent && !__classPrivateFieldGet(this, _Keys_inputKeys, "f").nested.includes(point.row)) {
        __classPrivateFieldGet(this, _Keys_inputKeys, "f").nested.push(point.row);
    }
}, _Keys_addInputCategoryKey = function _Keys_addInputCategoryKey(tag) {
    let categoryKeys = __classPrivateFieldGet(this, _Keys_inputKeys, "f").category.find((keys) => keys.categoryId === tag.categoryId);
    if (!categoryKeys) {
        __classPrivateFieldGet(this, _Keys_inputKeys, "f").category.push({
            categoryId: tag.categoryId,
            keys: [tag.value],
        });
    }
    else if (!categoryKeys.keys.includes(tag.value)) {
        categoryKeys.keys.push(tag.value);
    }
};
exports.default = Keys;
//# sourceMappingURL=keys.js.map