"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.toColSize = exports.dumpFooter = exports.dumpBody = exports.dumpHeader = exports.dumpCell = void 0;
const dumpCell = (cell) => {
    const contents = {
        value: cell.value,
        row: cell.rowKey,
        column: cell.columnKey,
        points: cell.getPoints().map((point) => {
            return {
                value: point.value,
                meta: point.getMetas(),
                tags: point.tags,
            };
        }),
    };
    console.log(contents);
};
exports.dumpCell = dumpCell;
const dumpHeader = (firstColSize, colSize, colKeys) => {
    console.log();
    let header = (0, exports.toColSize)("", firstColSize);
    colKeys.forEach((colKey, c) => {
        header = header + (0, exports.toColSize)(colKey, colSize);
    });
    console.log(header);
};
exports.dumpHeader = dumpHeader;
const dumpBody = (firstColSize, colSize, rowKeys, colKeys, cells, renderCell) => {
    rowKeys.forEach((rowKey, r) => {
        let row = (0, exports.toColSize)(rowKey, firstColSize);
        colKeys.forEach((colKey, c) => {
            const cell = cells.find((cell) => cell.rowKey === rowKey && cell.columnKey === colKey);
            let value = "-";
            if (cell) {
                value = renderCell ? renderCell(cell) : cell.getValue();
            }
            row = row + (0, exports.toColSize)(value, colSize);
        });
        console.log(row);
    });
};
exports.dumpBody = dumpBody;
const dumpFooter = (firstColSize, colSize, colKeys) => {
    const line = (0, exports.toColSize)("-", firstColSize + colSize * colKeys.length, "-");
    console.log(line);
};
exports.dumpFooter = dumpFooter;
const toColSize = (s, size, fill) => {
    fill = fill || " ";
    let content = String(s);
    const right = size - content.length;
    if (right >= 0) {
        for (let i = 0; i <= right; i++) {
            content = content + fill;
        }
        return content;
    }
    return content.slice(0, size + 1);
};
exports.toColSize = toColSize;
//# sourceMappingURL=dump.js.map