import { Datasheet, ParserOptions, RawResultInfo, RawResultMeta, RawRow } from "../types/types";
import { Parser } from "./parser";
export declare class Gesstabs extends Parser {
    constructor(config: ParserOptions);
    fromCsv(file: string): Promise<Datasheet[]>;
    fromXlsx(file: string): Promise<Datasheet[]>;
    autoDetectConfig(data: any): void;
    parseSections(data: RawRow): void;
    deduplicateRowLabels(data: RawRow): string;
    parseMeta(data: RawRow, firstCell: string): boolean;
    parseNested(data: RawRow, firstCell: string): boolean;
    parseSigniHeader: (cells: string[], meta: RawResultMeta[]) => string[];
    parseSigniValues: (cell: string, colId: number, rowLabel: string, meta: RawResultMeta[], signiHeaderLetters: RawResultInfo[]) => string;
    getSigniMap: (signiCellInfo: string, signiHeaderLetters: RawResultInfo[], colId: number) => RawResultInfo[];
    pushSigniMap(signiMap: RawResultInfo[], value: string, info: string, key: string): void;
}
