import { RawResultData, DataTag, RawColumnSlice, ParserOptions, RawTable, Datasheet, RawRow, RawResultMeta, RawResultNestedParent, RawResultNestedItem, RawResultInfo } from "../types/types";
export declare class Parser {
    results: RawResultData[];
    nested: RawResultNestedParent[];
    config: ParserOptions;
    currentSection: string;
    count: number;
    datasheets: Datasheet[];
    tableSeparator: string;
    file: string;
    constructor(config: ParserOptions);
    setDatasheets(): void;
    getTag(category: string, value: string): DataTag;
    removeCategoryDuplicates(tags: DataTag[]): void;
    parseColumnSlices(header: RawRow[]): RawColumnSlice[];
    sliceColumns(table: RawResultData, subgroupHeaders: RawRow[], slices: RawColumnSlice[], tags: DataTag[]): RawTable[];
    renderBody(body: RawRow[], slice: RawColumnSlice, rawTable: RawTable): void;
    renderMeta(meta: RawResultMeta[], slice: RawColumnSlice, rawTable: RawTable): void;
    renderHeader(subgroupHeader: RawRow, slice: RawColumnSlice, rawTable: RawTable): void;
    renderNested(nested: RawResultNestedItem[], rawTable: RawTable): void;
    pushMeta: (label: string, key: string, info: RawResultInfo[], meta: RawResultMeta[]) => void;
}
