import { Datasheet, DataTag, ParserOptions, ParserOptionsPsppCommands, ParserOptionsPsppFilters, ParserOptionsPsppKeys, ParserOptionsPsppLabels } from "../types/types";
import { Parser } from "./parser";
type PsppItem = {
    index: number;
    commandName: string;
    rowVar: string;
    columnVar: string;
    filters: ParserOptionsPsppFilters[];
    syntax: string;
};
type PsppStack = {
    items: PsppItem[];
    byIndex: (i: number) => PsppItem;
};
type PsppDatasheet = Datasheet & {
    count: number;
    mapColumns: number[];
    index: number;
};
export declare class Pspp extends Parser {
    constructor(config: ParserOptions);
    fromSav(file: string): Promise<PsppDatasheet[]>;
    getDatasheets(parsedCsv: string[][], keys: ParserOptionsPsppKeys, spsStack: PsppStack, addTags: DataTag[]): PsppDatasheet[];
    setMeta(currentDatasheet: PsppDatasheet, row: string[]): void;
    setColumns(currentDatasheet: PsppDatasheet, row: string[], totalLabel: string): void;
    setSheetData(parsedCsv: string[][], r: number, currentDatasheet: PsppDatasheet): void;
    getDefaultDatatable(currentTableIndex: number, questionText: string, currentStackItem: PsppItem, addTags: DataTag[]): PsppDatasheet;
    getSpsStack(commands: ParserOptionsPsppCommands[], filters: ParserOptionsPsppFilters[]): PsppStack;
    getSpsCommand(name: any, args: any): string;
    renameLabels(datasheets: PsppDatasheet[], labels: ParserOptionsPsppLabels[]): void;
    replaceLabelsBySection(datasheets: PsppDatasheet[], section: "rows" | "columns", label: ParserOptionsPsppLabels): void;
    replaceLabelsByTag(datasheets: PsppDatasheet[], label: ParserOptionsPsppLabels): void;
    writeTmpSpsFile(file: string, spsStack: PsppStack): string;
    callPspp(psppBin: string, tmpFilename: string): Promise<any>;
    static floatify(str: string): number;
    static getKeys(lang: "de" | "en"): ParserOptionsPsppKeys;
}
export {};
