import { DataPoint, DataPointMeta, DataPointTarget, Datasheet, DataTag, ModArgsExclude, ModArgsFilter, ModArgsMap, ModArgsRename, ModArgsStringTolabel, ModArgsTagTolabel, RawResultMeta, RenameLabel } from "./types/types";
import { CellValue } from "./modelizer/modelizer-types";
export default class Points {
    points: DataPoint[];
    constructor(points: DataPoint[]);
    static dataPointFactory(rowKey?: string, colKey?: string, tags?: DataTag[], meta?: DataPointMeta[], value?: CellValue): DataPoint;
    static getMetaCb(point: DataPoint, key: string): DataPointMeta | undefined;
    static setMetaCb(point: DataPoint, key: string, value: any): DataPoint;
    static getTagCb(point: DataPoint, categoryId: number): DataTag | undefined;
    targetPoints(points?: DataPoint[]): DataPoint[];
    filter(args: ModArgsFilter): DataPoint[];
    exclude(args: ModArgsExclude): void;
    addStringToLabel(args: ModArgsStringTolabel, points?: DataPoint[]): void;
    addTagToLabel(args: ModArgsTagTolabel, points?: DataPoint[]): void;
    map(args: ModArgsMap, points?: DataPoint[]): void;
    rename(args: ModArgsRename, points?: DataPoint[]): void;
    getRenameTargets(rename: RenameLabel): DataPointTarget[];
    applyRenameLabel(targets: DataPointTarget[], rename: RenameLabel, point: DataPoint): void;
    replace(replaceBy: DataPoint[]): void;
    push(addPoints: DataPoint[]): void;
    dump(points?: DataPoint[]): void;
    static getDataPointMeta(sheet: Datasheet, r: number, c: number): DataPointMeta[];
    static pushPointInfo(metaContent: RawResultMeta, pointMeta: DataPointMeta[], sheet: Datasheet, r: number, c: number): void;
    static pushPointNestedMeta(metaContent: RawResultMeta, pointMeta: DataPointMeta[], sheet: any, r: number, c: number): void;
    static metaHasRows(metaData: any): boolean;
    static pushPointMeta(pointMeta: DataPointMeta[], key: string, value: any): void;
}
